#include "Terrain.h"
Terrain::Terrain(pcStr heightFile,pcStr surfaceTexFile,GLuint width,GLint height){
	_map_width=width;//  μ ũ 
	_map_height=height;

	img=NULL;//   Ʈ̹  ʱȭ
	_texId_ground=0;_texId_water=0;//ؽ id
	_height=0;

	////////////ؽ   /////////////
	img=auxDIBImageLoad(surfaceTexFile);//ؽ̹ ε
	glGenTextures(1,&_texId_ground);// ؽ 
	glBindTexture(GL_TEXTURE_2D,_texId_ground); //ؽid 
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,img->sizeX,img->sizeY,0,GL_RGB,GL_UNSIGNED_BYTE,img->data);//2dؽ̹
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);// εɹü  ؽ  
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);// ιü Ŭ ؽ Ȯ  
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	/////////////////////////////////////////////////

	/////////////ؽ   /////////////
	const char *waterTexFile="space/water.bmp";
	img=auxDIBImageLoad(waterTexFile); // ̹ ε
	glGenTextures(1,&_texId_water);//ؽid 
	glBindTexture(GL_TEXTURE_2D,_texId_water);
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,img->sizeX,img->sizeY,0,GL_RGB,GL_UNSIGNED_BYTE,img->data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	////////////////////////////////////////////////

	_height=readRawData(heightFile,width,height);// Ϸκ μθŭ  ͸ о
	
	//  ּҰ 
	int i;
	for(i=0,minHeight=2^10;i<_map_width*height;i++) {
		if (minHeight>_height[i]){minHeight=_height[i];}
	}
	// ̴ ּ 60ġ
	waterLevel=(GLfloat)minHeight+100;
	//  ּҳ̸  ߶󳻸
	for (int i=0;i<_map_width*_map_height+1;i++) _height[i]-=minHeight;
	//  Ÿϸϱ
	baseTerrain=glGenLists(5);// 4ܰ  Ÿ,  5 ÷̸Ʈ
	glNewList(baseTerrain,GL_COMPILE);
	TileTerrain(1);//detail level1 
	glEndList();
	glNewList(baseTerrain+1,GL_COMPILE);
	TileTerrain(4);//detail level2 
	glEndList();
	glNewList(baseTerrain+2,GL_COMPILE);
	TileTerrain(8);//detail level3 
	glEndList();
	glNewList(baseTerrain+3,GL_COMPILE);
	TileTerrain(16);//detail level4 
	glEndList();
	glNewList(baseTerrain+4,GL_COMPILE);
	RenderWater();// ׸
	glEndList();
}
Terrain::~Terrain(){
	// Terrainü Ҹ ޸𸮸 ȯѴ
	if (_height!=0){delete[] _height;}
	if (_texId_ground!=0){glDeleteTextures(1,&_texId_ground);}
	if (_texId_water!=0){glDeleteTextures(1,&_texId_water);}
	if (img!=0){free(img->data);free(img);}
}

void Terrain::RenderTerrain(GLfloat x,GLfloat y){
	int i,j;
	// Ÿϸ  ÷̸Ʈ ҷ Լ
	//detail level1 
	//ī޶ ġ    ׸.
	glPushMatrix();
		glTranslatef(getTileX(x)*(_map_width-1),0.0,getTileY(y)*(_map_height-1));
		glCallList(baseTerrain);
	glPopMatrix();
	//detail level2 
	//level1 ϰ 3x3 ׸.
	for (i=-1;i<2;i++){
		for (j=-1;j<2;j++){
			if (!(i==0&&j==0)){
				glPushMatrix();
				glTranslatef(getTileX(x)*(_map_width-1)+(i*(_map_width-1)),0.0,getTileY(y)*(_map_height-1)+(j*(_map_height-1)));
				glCallList(baseTerrain+1);
				glPopMatrix();
			}
		}
	}
	//detail level3 
	//level2 ϰ 5x5 ׸.
	for (i=-2;i<3;i++){
		for (j=-2;j<3;j++) {
			if ((i<-1 || i>1) || (j<-1 ||j>1)){
				glPushMatrix();
				glTranslatef(getTileX(x)*(_map_width-1)+(i*(_map_width-1)),0.0,getTileY(y)*(_map_height-1)+(j*(_map_height-1)));
				glCallList(baseTerrain+2);
				glPopMatrix();
			}
		}
	}
	//detail level4 
	//level2 ϰ 7x7 ׸.
	for (i=-3;i<4;i++){
		for (j=-3;j<4;j++) {
			if ((i<-2 || i>2) || (j<-2 ||j>2)){
				glPushMatrix();
				glTranslatef(getTileX(x)*(_map_width-1)+(i*(_map_width-1)),0.0,getTileY(y)*(_map_height-1)+(j*(_map_height-1)));
				glCallList(baseTerrain+3);
				glPopMatrix();
			}
		}
	}
	// ÷ Ʈ
	//3x3 ׸
	for (i=-2;i<3;i++){
		for (j=-2;j<3;j++){
			glPushMatrix();
			glTranslatef(getTileX(x)*(_map_width-1)+(i*(_map_width)-1),0.0,getTileY(y)*(_map_height-1)+(j*(_map_height-1)));
			glCallList(baseTerrain+4);
			glPopMatrix();
		}
	}
}
void Terrain::TileTerrain(GLint levelOfDetail){ //levelOfDetailĶ͸ ޾  Ÿ ׸ Լ
	glEnable(GL_TEXTURE_2D); //ؽȰȭ
	glMatrixMode(GL_MODELVIEW);//𵨺

	glPushMatrix();

	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);//ؽȯ漳
	glBindTexture(GL_TEXTURE_2D,_texId_ground); //ؽ id Ű ؽķ Ʒ  
	float coordX=(float)1.0/_map_width; // ̵
	float coordZ=(float)1.0/_map_height;// ̵
	for (int z=0;z<_map_height;z+=levelOfDetail){ // x,z  ׸  ٴڿ ϱ 
		glBegin(GL_TRIANGLE_STRIP);// ӻﰢ ׸ ؽĸ
		for (int x=0;x<_map_width;x+=levelOfDetail){
			glTexCoord2f(coordX*x,coordZ*z); // ؽ
			glVertex3f(x,_height[z*_map_height+x],z);// ü 
			glTexCoord2f(coordX*x,coordZ*(z+levelOfDetail));// ؽ
			glVertex3f(x,_height[(z+levelOfDetail)*_map_height+x],z+levelOfDetail);// ü 
		}
		glEnd();
	}
	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
}
void Terrain::RenderWater(){//׸
	glEnable(GL_TEXTURE_2D);// ؽȰȭ
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);//ؽȯ漳
	//glPushAttrib(GL_ENABLE_BIT);

	glEnable(GL_BLEND);//Ȱȭ
	glDisable(GL_CULL_FACE);//ĸźȰȭ
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);//
	glColor4f(0.0,0.4,0.5,0.7);

	glBindTexture(GL_TEXTURE_2D,_texId_water);// ؽĸ
	glBegin(GL_QUADS);// 簢 ׸
		glTexCoord2f(0.0,0.0);	glVertex3f(0.0,waterLevel,0.0);//   ϰ 
		glTexCoord2f(15.0,0.0);	glVertex3f(0.0,waterLevel,_map_height);
		glTexCoord2f(15.0,15.0);glVertex3f(_map_height,waterLevel,_map_height);
		glTexCoord2f(0.0,15.0);	glVertex3f(_map_height,waterLevel,0.0);
	glEnd();
	glEnable(GL_CULL_FACE);// ĸȰȭ
	glDisable(GL_BLEND);//  Ȱȭ
	//glPopAttrib();
	glDisable(GL_TEXTURE_2D);
}
// raw  д Լ
// filename: ̸  
// w : ̸  ũ
// h : ̸  ũ
Terrain::ubyte* Terrain::readRawData(pcStr filename,uint w,uint h){
	FILE *f;
	fopen_s(&f,filename,"rb"); // ̵ rawϿ
	if (!f){// 
		printf("file not found : %s\n",filename);
		throw std::exception();
	}
	//   raw  ," ũ=̹ ȼ"̱
	//  width*height ũ ŭ  Ҵϸ  ͸ о  
	ubyte* raw=new ubyte[w*h];// raw ũ⸦ 
	fread(raw,sizeof(ubyte),w*h,f);// ̵о
	fclose(f);
	return raw;
}
GLfloat Terrain::getHeight(GLfloat _x,GLfloat _y){
	//ؽ̹ ش _x,_y  ͸   Լ
	int x,y;
	if(_x<0) x=_map_width+((int)_x%_map_width);//ؽ̹ Ѿ ݴǥ
	else x=((int)_x % _map_width);
	if(_y<0) y=_map_height + ((int)_y % _map_height);
	else y=((int)_y % _map_height);
	// ǥ ؽũȿ Ŵ
	//  ʹ 1迭 Ǿ Ƿ ó
	return (_height[y*_map_height+x]/5+10);// شġ ̰ ȯ
}
GLint Terrain::getTileX(GLfloat x){// ī޶ ġϰ ִ ؽ Ÿ ǥ ȯ : xǥ
	if (x>0) return ((int)x)/(int)_map_width;
	else return ((int)x)/(int)_map_width-1;
}
GLint Terrain::getTileY(GLfloat y){//// ī޶ ġϰ ִ ؽ Ÿ ǥ ȯ : yǥ
	if (y>0) return ((int)y)/(int)_map_height;
	else return ((int)y)/(int)_map_height-1;
}